package cn.ezhizao.project.business.channel.controller;

import java.util.List;
import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;

import cn.ezhizao.project.business.channel.domain.BizChannel;
import cn.ezhizao.project.business.channel.service.IBizChannelService;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import cn.ezhizao.framework.aspectj.lang.annotation.Log;
import cn.ezhizao.framework.aspectj.lang.enums.BusinessType;

import cn.ezhizao.framework.web.controller.BaseController;
import cn.ezhizao.framework.web.domain.AjaxResult;
import cn.ezhizao.common.utils.poi.ExcelUtil;
import cn.ezhizao.framework.web.page.TableDataInfo;

/**
 * 渠道Controller
 *
 * @author ruoyi
 * @date 2023-10-26
 */
@RestController
@RequestMapping("/business/channel")
public class BizChannelController extends BaseController
{
    @Resource
    private IBizChannelService bizChannelService;

    /**
     * 查询渠道列表
     */
    @PreAuthorize("@ss.hasPermi('business:channel:list')")
    @GetMapping("/list")
    public TableDataInfo list(BizChannel bizChannel) throws NoSuchFieldException, IllegalAccessException
    {
        setTenantId(bizChannel);
        startPage();
        startOrderBy();
        List<BizChannel> list = bizChannelService.getList(bizChannel);
        return getDataTable(list);
    }

    /**
     * 导出渠道列表
     */
    @PreAuthorize("@ss.hasPermi('business:channel:export')")
    @Log(title = "渠道", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, BizChannel bizChannel) throws NoSuchFieldException, IllegalAccessException
    {
        setTenantId(bizChannel);
        List<BizChannel> list = bizChannelService.getList(bizChannel);
        ExcelUtil<BizChannel> util = new ExcelUtil<BizChannel>(BizChannel.class);
        util.exportExcel(response, list, "渠道数据");
    }

    /**
     * 获取渠道详细信息
     */
    @PreAuthorize("@ss.hasPermi('business:channel:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return success(bizChannelService.getById(id));
    }

    /**
     * 新增渠道
     */
    @PreAuthorize("@ss.hasPermi('business:channel:add')")
    @Log(title = "渠道", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody BizChannel bizChannel) throws NoSuchFieldException, IllegalAccessException
    {
        setTenantId(bizChannel);
        return toAjax(bizChannelService.save(bizChannel));
    }

    /**
     * 修改渠道
     */
    @PreAuthorize("@ss.hasPermi('business:channel:edit')")
    @Log(title = "渠道", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody BizChannel bizChannel) throws NoSuchFieldException, IllegalAccessException
    {
        setTenantId(bizChannel);
        return toAjax(bizChannelService.updateById(bizChannel));
    }

    /**
     * 删除渠道
     */
    @PreAuthorize("@ss.hasPermi('business:channel:remove')")
    @Log(title = "渠道", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable List<Long> ids)
    {
        return toAjax(bizChannelService.removeBatchByIds(ids));
    }
}
